#!/usr/bin/env python3
import sys
import math
from collections import namedtuple as T

C = T("C", "x y r")
P = T("P", "x y")


def point_in_circle(p, c):
    return math.hypot(p.x - c.x, p.y - c.y) <= c.r


def point_inside(p, circles):
    for c in circles:
        if point_in_circle(p, c):
            return True
    return False


n = int(sys.stdin.readline())
circles = []
for _ in range(n):
    circles.append(C(*map(int, sys.stdin.readline().split())))

yes = 0
no = 0
for i in range(-30, 31):
    for j in range(-30, 31):
        if point_inside(P(i, j), circles):
            yes += 1
        else:
            no += 1

area = 60 * 60
print(area * yes / (yes + no))
