import subprocess
import random

#CORRECT_SOLUTION = ["../submissions/run_time_error/jimmy_n2m"]
CORRECT_SOLUTION = ["../submissions/accepted/jimmy_n3"]
#CORRECT_SOLUTION = ["python", "../submissions/accepted/jimmy_n3.py"]
#TEST_SOLUTION = ["python", "../submissions/accepted/jimmy_n3.py"]
#TEST_SOLUTION = ["../submissions/accepted/jimmy_n3"]
#TEST_SOLUTION = ["../submissions/accepted/per_n4"]
#TEST_SOLUTION = ["python", "../submissions/accepted/per_n3.py"]
TEST_SOLUTION = ["python", "../submissions/wrong_answer/per_wrong3.py"]
# TEST_SOLUTION = ["../submissions/wrong_answer/jimmy_wrong5"]
#TEST_SOLUTION = ["../submissions/wrong_answer/bug5"]
TMP_DATA_FILE = "tmpdata.tmp"


def verify(n, m, x, data):
    with open(TMP_DATA_FILE, "w") as f:
        f.write(f"{m} {x} {n}\n")
        for row in data:
            f.write(f"{row[0]} {row[1]} {row[2]}\n")

    with open(TMP_DATA_FILE) as f:
        res = subprocess.run(CORRECT_SOLUTION, capture_output=True, stdin=f)
        expected_answer = int(res.stdout)

    with open(TMP_DATA_FILE) as f:
        res = subprocess.run(TEST_SOLUTION, capture_output=True, stdin=f)
        actual_answer = int(res.stdout)

    if expected_answer != actual_answer:
        raise Exception(f"Answers mismatch {expected_answer} != {actual_answer}")

def random_intervals(m, n, maxv):
    x = set()
    while len(x) < 2*n:
        x.add(random.randint(0, m))
    x = list(sorted(x))
    return [(x[i*2], x[i*2+1], random.randint(1, maxv)) for i in range(n)]


random.seed(0)

cases = 0
while True:
    N1 = random.randint(2, 7)
    N2 = random.randint(2, 7)
    if N1 + N2 < 1:
        continue
    M = random.randint(20, 50)

    V = 20
    X = random.randint(1, M * 2)

    upper = random_intervals(M, N1, V)
    lower = random_intervals(M, N2, V)
    lower = [(b,a,c) for (a,b,c) in lower]
    data = [*upper, *lower]
    assert len(data) == N1+N2

    verify(N1+N2, M, X, data)

    cases += 1
    if cases % 100 == 0:
        print(f"{cases} cases tried...")
